
C  bpak -- package to interface host programs with GIGI BASIC
C  August  1981
C  R. J. Fleischer
C 
C 
C   			D I S C L A I M E R
C   
C    
C    
C   	The information in this software is subject to change  without 
C   	notice  and should not be construed as a commitment by Digital 
C   	Equipment Corporation. 
C    
C   	DIGITAL assumes no responsibility for the use  or  reliability 
C   	of this software.
C    
C 	This software is not supported by DIGITAL.
C 
C  operating-system-dependent switches
C ========== Ratfor character definitions ==========
C 	 9-FEB-79
C 	12-MAY-80
C 	28-AUG-81
C  ampersand
C  exclamation mark
C  ASCIZ strings as used by SYSLIB
C  max length of a file spec
C  max element count in packed char array
C  input record size
C  must be 2 more than MAXRECORD
C  alternative to YES, NO
C  a linefeed
C  for OPENF calls
C 	"
C 	"
C 	"
C  first char in FORMAT with LIST carriagecontrol
C  ascii numeric value corresponding to LISTSS, above
C  char i/o format:  "r1" for TOPS-20
C TOPS	define(CHARFORMAT,r1)	#	"a1" otherwise
C  quoted string version of above
C TOPS	define(CHARFORMATQ,'r1')
C  if "#", omit packed string code
C  5 for TOPS-20, 1 otherwise
C TOPS	define(PACKEDDENSITY,5)
C  on this machine, unpack == scopyl
C 	"	", pack == scopy
C TOPS	define(character,integer)
C  end of standard system defines
C =============================================================================

C lun for logging GIGI-BASIC interactions
C  "#" to disable debugging code, blank otherwise
C  ba2on -- enter ba2 (HOST BASIC) mode
      logical function ba2on
C  returns true if successful
      implicit integer ( a - z )
      common / bpkcom / inba2
      logical inba2
      logical ba2out
      byte onba2(14)
      data onba2 /13,155,'[','?','2','2','l',155,'[','?','2','2','h',0/
      data inba2 / . false . /
      if(.not.( .not. inba2 ))goto 23000
C  must not be in ReGIS
      inba2 = ba2out ( onba2 )
      if(.not.( .not. inba2 ))goto 23002
C  retry once
      inba2 = ba2out ( onba2 )
23002 continue
      ba2on = inba2
      return
23000 continue
      ba2on = . true .
      return
      end

C  ba2on
C  ba2off -- exit ba2 (host basic) mode
      logical function ba2off
C  returns true always
      implicit integer ( a - z )
      common / bpkcom / inba2
      logical inba2
      logical ba2out
      byte offba2(8)
      data offba2 /13,155,'[','?','2','2','l',0/
      ba2off = . true .
      inba2 = . false .
      call putln ( offba2 , length ( offba2 ) )
      call putln ( 0 , 0 )
C  ensure i/o completion
      return
      end

C  ba2off
C  ba2out -- send a string to GIGI BASIC, then get and analyze the response
      logical function ba2out ( str )
C  returns true if "Ok"
      implicit integer ( a - z )
      byte str ( 1 )
C  the following are funtions defined in RATLIB
      logical openf , openio , ispack , putstr , ptprmt
      integer getstr , scopy , scopyl , length , trim , rpad , lpad , is
     *comp , indexx , rindex , ctoi , equal , stemeq , itoc , type , spl
     *ice , upper , lower , makeuc , makelc , cvt , lengp , u n p a c k 
     *, p a c k , skipbl , findbl , ftocg , strsub , matchs , puttyp , p
     *rsdir
      integer ttin , ttinnw , getln , prmtgt
      common / bpkcom / inba2
      logical inba2
      byte respns ( 21 )
      byte ok(3)
      data ok /'O','k',0/
      ba2out = . false .
C  assume failure
C DEBUG	call putstr (GGBASLOG, str, BLANK)
      continue
23004 if(.not.( ttinnw ( 0 ) .gt. 0 ))goto 23005
C  flush any type-ahead with no echo
      goto 23004
23005 continue
      call putln ( str , length ( str ) )
      call putln ( 13 , 1 )
C  add CR to make BASIC execute it
      call getln ( respns , 20 , 0 )
C  read with no echo
      ba2out = ( indexx ( respns , ok , 1 ) .gt. 0 )
C  true if OK is response
      if(.not.( .not. ba2out ))goto 23006
C  retry ONCE if failed
C DEBUG	call putstr (GGBASLOG, respns, BLANK)
      call getln ( respns , 20 , 0 )
C  read with no echo
      ba2out = ( indexx ( respns , ok , 1 ) .gt. 0 )
C  true if OK is response
23006 continue
      continue
23008 if(.not.( ttinnw ( 0 ) .gt. 0 ))goto 23009
C  flush any extra input
C DEBUG	call putstr (GGBASLOG, respns, BLANK)
      goto 23008
23009 continue
      return
      end

C  ba2out
C  ba2 -- send a character string to GIGI in BA2 mode
      logical function ba2 ( str )
C  returns true if BASIC responds "Ok"
      implicit integer ( a - z )
      byte str ( 1 )
      logical ba2on , ba2out
      ba2 = ba2on ( 0 )
C  dummy arg
      if(.not.( .not. ba2 ))goto 23010
      return
C  error if could not start up BA2 mode
23010 continue
      ba2 = ba2out ( str )
      return
      end

C  ba2
C  doggm2 -- execute the ".ggm" program previously loaded into font #2
      logical function doggm2
C  returns true if BASIC responds "Ok"
      implicit integer ( a - z )
C  the following are funtions defined in RATLIB
      logical openf , openio , ispack , putstr , ptprmt
      integer getstr , scopy , scopyl , length , trim , rpad , lpad , is
     *comp , indexx , rindex , ctoi , equal , stemeq , itoc , type , spl
     *ice , upper , lower , makeuc , makelc , cvt , lengp , u n p a c k 
     *, p a c k , skipbl , findbl , ftocg , strsub , matchs , puttyp , p
     *rsdir
      integer ttin , ttinnw , getln , prmtgt
      logical ba2
      byte respns ( 21 )
      byte qalpha(15)
      byte ggm2(6)
      byte poke1(18)
      byte poke2(18)
      byte useusr(9)
      data qalpha /155,'P','p','l','(','a','2',')','r','(','l',')',155,'
     *\',0/
      data ggm2 /'2','.','g','g','m',0/
      data poke1 /'p','o','k','e',' ','&','h','9','d','9','4',',',' ','&
     *','h','2','1',0/
      data poke2 /'p','o','k','e',' ','&','h','9','d','9','5',',',' ','&
     *','h','8','6',0/
      data useusr /'a','=','u','s','r','(','1',')',0/
      call ba2off
      continue
23012 if(.not.( ttinnw ( 0 ) .gt. 0 ))goto 23013
C  flush type-ahead
C  check if font #2 has the right ID
      goto 23012
23013 continue
      call putln ( qalpha , length ( qalpha ) )
      call getln ( respns , 20 , 0 )
      doggm2 = ( indexx ( respns , ggm2 , 1 ) .gt. 0 )
C  must contain "2.ggm"
C DEBUG	call putstr (GGBASLOG, respns, BLANK)
      if(.not.( doggm2 ))goto 23014
      doggm2 = ba2 ( poke1 )
23014 continue
      if(.not.( doggm2 ))goto 23016
      doggm2 = ba2 ( poke2 )
23016 continue
      if(.not.( doggm2 ))goto 23018
      doggm2 = ba2 ( useusr )
23018 continue
      call ba2off
      return
      end
