************************************************************************
*                                                                      *
*	SUBROUTINE PASSWORD (ERROR)                                    *
*                                                                      *
*	PURPOSE: PROMPT USER FOR PASSWORD AND VERIFY USER INPUT WITH   *
*	         THE CURRENT ENCODED PASSWORD IN THE FILE 'PASSWD.DAT' *
*                                                                      *
************************************************************************

	SUBROUTINE PASSWORD (ERROR)

	IMPLICIT INTEGER (A-Z)
	BYTE ERROR
	CHARACTER INPUTPW(9)
	BYTE NEWCODE(9), OLDCODE(9) 

******	GET USER INPUT  ******

	WRITE (*,10)
  10	FORMAT( 1X,'BOOST> ENTER PASSWORD :  ',$)

******  SET TERMINAL IN NO-ECHO MODE TO ACCEPT PASSWORD  ******

	CALL NOECHO(INPUTPW)

******  ENCODE PASSWORD  *******

	CALL PWENCODE (INPUTPW,NEWCODE)
 
******  OPEN PASSWORD DATA FILE AND READ IN THE OLD PASSWORD CODE  *******

 	OPEN (UNIT=21,FILE='DRA0:[SYSMGR.BOOST]PASSWD.DAT',STATUS='OLD'
     *	,SHARED)
	READ (21,11) OLDCODE 
  11	FORMAT (9A1)

******  COMPARE OLD CODE WITH INPUT PASSWORD CODE  *******

	ERROR = .FALSE.
	I=1
	DO WHILE ((ERROR .EQ. .FALSE.) .AND. (I .LE. 9))
	IF (OLDCODE(I) .NE. NEWCODE(I)) THEN
	       ERROR = .TRUE.
	  ELSE 
	       I = I + 1
	END IF
	END DO

******* CLOSE PASSWORD FILE AND RETURN *******

	CLOSE (UNIT=21,STATUS='KEEP')
	RETURN
	END

